#include <string>	
#include <iostream>
#include <Windows.h>
#include <gl/GL.h>
#include <gl/GLU.h>

#include "glfw3.h"
#include <stdlib.h>
#include <stdio.h>

using namespace std;


unsigned int screenwidth = 800;
unsigned int screenheight = 600;

void error_callback(int error, const char* description)
{
	cout << description << endl;
	system("pause");
	exit(-1);
}

void key_callback(GLFWwindow* window, int key, int scancode, int action, int mods)
{
	if (key == GLFW_KEY_ESCAPE && action == GLFW_PRESS) glfwSetWindowShouldClose(window, GL_TRUE);
}


void RenderFunction(void)
{
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

	glRotatef(1,0,1,0);

	glBegin(GL_TRIANGLES);                    
		glColor3f(1,0,0);
		glVertex3f( 0.0f, 1.0f, 0.0f);              // Top
		glColor3f(0,1,0);
		glVertex3f(-1.0f,-1.0f, 0.0f);              // Bottom Left
		glColor3f(0,0,1);
		glVertex3f( 1.0f,-1.0f, 0.0f);              // Bottom Right
	glEnd(); 
}

int main(void)
{
	glfwSetErrorCallback(error_callback);

	if (!glfwInit()) error_callback(0,"Error: glfwInit()");

	glfwWindowHint( GLFW_RESIZABLE, GL_FALSE );

	GLFWwindow* window;
	window = glfwCreateWindow(screenwidth, screenheight, "Simple example", NULL, NULL);
	if (!window)
	{
		glfwTerminate();
		error_callback(0,"Error: glfwCreateWindow()");
	}

	glfwMakeContextCurrent(window);
	
	glfwSetKeyCallback(window, key_callback);

	while (!glfwWindowShouldClose(window))
	{

		glfwPollEvents();

		RenderFunction();

		glfwSwapBuffers(window);
		
	}
	
	glfwDestroyWindow(window);
	glfwTerminate();
}
