#include <string>
#include <iostream>
#include <Windows.h>
#include <gl/GL.h>
#include <gl/GLU.h>

#include <SDL.h>

using namespace std;


unsigned int screenwidth = 800;
unsigned int screenheight = 600;


void error(string errstr)
{
	cout << errstr << endl;
	system("pause");
	exit(-1);
}

void RenderFunction(void)
{
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

	glRotatef(1,0,1,0);

	glBegin(GL_TRIANGLES);                    
		glColor3f(1,0,0);
		glVertex3f( 0.0f, 1.0f, 0.0f);              // Top
		glColor3f(0,1,0);
		glVertex3f(-1.0f,-1.0f, 0.0f);              // Bottom Left
		glColor3f(0,0,1);
		glVertex3f( 1.0f,-1.0f, 0.0f);              // Bottom Right
	glEnd(); 
}




int main(int argc, char** argv)
{
     if ( SDL_Init(SDL_INIT_VIDEO) != 0 ) error("Unable to initialize SDL2: " + (string) SDL_GetError());


	 SDL_Window *SDLwindow = SDL_CreateWindow("SDLtest", SDL_WINDOWPOS_CENTERED, SDL_WINDOWPOS_CENTERED, screenwidth,screenheight, SDL_WINDOW_OPENGL);
	 if (!SDLwindow) error("SDL_CreateWindow: "+ (string) SDL_GetError());


	 SDL_GLContext SDLopenGLcontext = SDL_GL_CreateContext(SDLwindow);
     if(!SDLopenGLcontext) error("Unable to initialize SDL2 OpenGL context: " + (string) SDL_GetError());


	 bool quit=false;
	 SDL_Event event;
	 while (!quit)
	 {

			//Event polling
			while (SDL_PollEvent(&event))
			{
				switch(event.type)
				{
					case SDL_QUIT: { quit = true; } break;
					case SDL_KEYDOWN: 
						{
							switch (event.key.keysym.sym)
							{
								case SDLK_ESCAPE: {quit = true;} break;
								default: break;
							}
						} break;
					default: break;
				}
			 }


			
			RenderFunction();

			SDL_GL_SwapWindow(SDLwindow);

	 }




 	 SDL_GL_DeleteContext(SDLopenGLcontext);
 	 SDL_DestroyWindow(SDLwindow);
 	 SDL_Quit();

	 return 0;
}